/* *
 * 	Un hombre requiere de una calculadora muy especial que permita sumar, restar, multiplicar,
 *	dividir, y obtener el módulo. Esta calculadora sólo acepta números de un dígito y luego de
 *	validados muestra en pantalla tanto los operandos como los operadores y los resultados en
 *	formato de numero agrandado.
 *	Los resultados siempre serán de un solo dígito, así: en la suma el resultado es el último dígito.
 *	En la multiplicación el resultado siempre sera el primer dígito, se requiere:
 *		* 1. Macro-algoritmo.
 *		* 2. Listado de funciones requeridas basadas en el algoritmo.
 *		* 3. Codificación de lenguaje C.
 *		* 4. Esquema funcional.
 */

#include <iostream>

using namespace std;

int unDigito (int n) // Si "n" es de un solo dígito devuelve el número, si no, devuelve 0
{
	if (n / 10 == 0)
		return n;
	return 0;
}

void formato(int n) // Muestra "n" en formato agrandado
{
	if (n == 0)
		cout << "\t  **\n\t *  *\n\t *  *\n\t  **";
	else if (n == 1)
		cout << "\t **\n\t***\n\t **\n\t **\n\t****";
	else if (n == -1)
		cout << "\t **\n\t***\n   ****\t **\n\t **\n\t****";
	else if (n == 2)
		cout << "\t  **\n\t *  *\n\t   *\n\t  *\n\t ****";
	else if (n == -2)
		cout << "\t  **\n\t *  *\n   ****\t   *\n\t  *\n\t ****";
	else if (n == 3)
		cout << "\t  ***\n\t     *\n\t    *\n\t     *\n\t  ***";
	else if (n == -3)
		cout << "\t  ***\n\t     *\n   ****\t    *\n\t     *\n\t  ***";
	else if (n == 4)
		cout << "\t   **\n\t  * *\n\t *  *\n\t *****\n\t    *\n\t    * ";
	else if (n == -4)
		cout << "\t   **\n\t  * *\n\t *  *\n   ****\t *****\n\t    *\n\t    * ";
	else if (n == 5)
		cout << "\t  ****\n\t  *\n\t  *\n\t  ***\n\t     *\n\t     *\n\t  ***";
	else if (n == -5)
		cout << "\t  ****\n\t  *\n\t  *\n   ****\t  ***\n\t     *\n\t     *\n\t  ***";
	else if (n == 6)
		cout << "\t    * *\n\t  *\n\t *\n\t *  * *\n\t *     *\n\t  *    *\n\t    **";
	else if ( n == -6)
		cout << "\t    * *\n\t  *\n\t *\n   ****\t *  * *\n\t *     *\n\t  *    *\n\t    **";
	else if (n == 7)
		cout << "\t *****\n\t     *\n\t    *\n\t   *\n\t   *\n\t   *";
	else if (n == -7)
		cout << "\t *****\n\t     *\n\t    *\n   ****\t   *\n\t   *\n\t   *";
	else if (n == 8)
		cout << "\t  ***\n\t *   *\n\t  ***\n\t *   *\n\t *   *\n\t  ***";
	else if (n == -8)
		cout << "\t  ***\n\t *   *\n   ****\t  ***\n\t *   *\n\t *   *\n\t  ***";
	else if (n == 9)
		cout << "\t ***\n\t*   *\n\t*   *\n\t ****\n\t   *\n\t **";
	else if (n == -9)
		cout << "\t ***\n\t*   *\n\t*   *\n   ****\t ****\n\t   *\n\t **";
}

void calcularModulo(int n, int m)
{
	int mod2 = unDigito(n); 			          // Almacena en "mod2" el número de un dígito
	int mod3 = unDigito(m); 		              // Almacena en "mod3" otro número de un dígito
	int mod = mod2 % mod3;                        // Obtiene el módulo y lo almacena en "mod"
	cout << "\n "<< mod2 << "%" << mod3 << "=" ;  // Muestra la operación módulo en pantalla
	formato(mod);
}

void dividir(int n, int m)
{
	int divi2 = unDigito(n);
	int divi3 = unDigito(m);
	int divi = divi2 / divi3;                      // Obtiene el cociente y lo almacena en "divi"
	cout << "\n " << divi2 << "/" << divi3 << "="; // Muestra la operación división en pantalla
	formato(divi);
}

void multiplicar(int n, int m)
{
	int multi2 = unDigito(n);
	int multi3 = unDigito(m);
	int multi = multi2 * multi3;                     // Obtiene el producto y loa almacena en "multi"
	cout << "\n " << multi2 << "*" << multi3 << "="; // Muestra la operación multiplicación en pantalla
	formato((multi % 100) / 10);
}

void restar(int n, int m)
{
	int resta2 = unDigito(n);
	int resta3 = unDigito(m);
	int resta1 = resta2-resta3;                      // Obtiene el resto y lo almacena en "resta1"
	cout << "\n " << resta2 << "-" << resta3 << "="; // Muestra la operación resta en pantalla
	formato(resta1);
}

void sumar(int n, int m)
{
	int suma2 = unDigito(n);
	int suma3 = unDigito(m);
	int suma1 = suma2 + suma3;                    // Obtiene la suma y la almacena en "suma1"
	cout << "\n " << suma2 << "+" << suma3 <<"="; // Muestra la operación suma en pantalla
	formato(suma1 % 10);
}

int leer(string cad) // Lee un número ingresado por el usuario
{
	int num;
	cout << cad;
	cin >> num;
	return num;
}

void menu2(int n) // Ejecuta una de las opciones del menú dependiendo del valor de entrada
{
	int num1 = leer("\n Digite un n\xA3mero: ");
	int num2 = leer(" Digite otro n\xA3mero: ");
	switch (n)
	{
		case 1: sumar(num1, num2); break;          // Llama a la función sumar
		case 2: restar(num1, num2); break;         // Llama a la función restar
		case 3: multiplicar(num1, num2); break;    // Llama a la función multiplicar
		case 4: dividir(num1, num2); break;        // Llama a la función dividir
		case 5: calcularModulo(num1, num2); break; // Llama a la función calcularModulo
		default: break;
	}
}

void menu() // Muestra el menú en pantalla
{
	int a;
	cout << " --------------------"
	     << "\n\tM E N \xE9"
	     << "\n --------------------"
	     << "\n    1. Sumar."
	     << "\n    2. Restar."
	     << "\n    3. Multiplicar."
	     << "\n    4. Dividir."
	     << "\n    5. M\xA2\x64ulo."
	     << "\n --------------------"
	     << "\n Digite su opci\xA2n: ";
	cin >> a;
	menu2(a);
}

int main() // Punto de entrada del programa
{
	menu();
	return 0;
}
